#include <octave/oct.h>
#include <parse.h>
#include <unistd.h>
#include <string>
#include <iostream>

#include "utils.h"

extern int gpt_lexit(std::string, std::string);

static bool gpt_ready = false;

/*
int gpt_init(void)
{

    std::cout << "gpt_init called\n";
    if(!gpt_ready) {
	symbol_record *sym_rec;
	sym_rec = fbi_sym_tab->lookup ("gpt", false, true);
	if(sym_rec) {
	    sym_rec->mark_as_rawcommand();
	}
	gpt_ready = true;
    }
}
*/

DEFUN_DLD(gpt, args,, "Parse gnuplot stuff.\n")
{
    octave_value_list retval;
    std::string s = "";
    int i = 0;

    while(i < args.length()) {
	std::cout << args(i).string_value() + "\n" + "-\n";
        s = s + args(i).string_value() + " ";
        i++;
    }
    
    std::cout << s << "\n";

    gpt_lexit("gplot", s);
    
    
/*     
// parse ranges
    
    i = 0;
    int open_braces = 0;
    int ranges = 0;    
    int expr_start, expr_end;
    std::string l_expr[3], r_expr[3];    
    while(ranges < 3) {    
        while(cs[i] && isspace(cs[i])) {
            i++;
        }
        std::cout << cs[i] << "\n";
        if(cs[i++] == '[') {
            open_braces = 1;
            ranges++;
            expr_start = i;
            while(cs[i] && open_braces >= 1 && cs[i] != ':') {
                i++;
                if(cs[i] == '[')
                    open_braces++;
                else if(cs[i] == ']')
                    open_braces--;
            }
            if(cs[i] == ':' && open_braces == 1) {
                expr_end = i;
                l_expr[ranges-1] = s.substr(expr_start, expr_end-expr_start);
            } else {
                error("Error parsing ranges");
            }
            i++;            
            expr_start = i;
            while(cs[i] && open_braces >= 1) {
                i++;
                if(cs[i] == '[')
                    open_braces++;
                else if(cs[i] == ']')
                    open_braces--;
            }
            if(cs[i] == ']' && open_braces == 0) {
                expr_end = i;
                r_expr[ranges-1] = s.substr(expr_start, expr_end-expr_start);
                i++;
            } else {
                error("Error parsing ranges");
            }
        } else {
            break; // no more ranges
        }    
    }

    std::cout << l_expr[0] << " , " << r_expr[0] << "\n";
    std::cout << l_expr[1] << " , " << r_expr[1] << "\n";
    std::cout << l_expr[2] << " , " << r_expr[2] << "\n";
    
    // parse plot expressions and option

*/
    
    retval = octave_value_list();    
    return retval;
}
